# std::uninitialized_default_construct

From cppreference.com
< cpp‎ | memory

Defined in header `<memory>` |  |
template< class ForwardIt > void uninitialized_default_construct( ForwardIt first, ForwardIt last); | (1) | (since C++17)
template< class ExecutionPolicy, class ForwardIt > void uninitialized_default_construct( ExecutionPolicy&& policy, ForwardIt first, ForwardIt last ); | (2) | (since C++17)

1) Constructs objects of type `typename iterator_traits<ForwardIt>::value_type` in the uninitialized storage designated by the range `[first, last)` by default-initialization, as if by

    for (; first != last; ++first)
      ::new (static_cast<void*>(std::addressof(*first)))
          typename std::iterator_traits<ForwardIt>::value_type;

If an exception is thrown during the initialization, the objects already constructed are destroyed in an unspecified order.
2) Same as (1), but executed according to `policy`. This overload does not participate in overload resolution unless std::is_execution_policy_v < std::decay_t <ExecutionPolicy>> is true

### Parameters

first, last | - | the range of the elements to initialize
policy | - | the execution policy to use. See execution policy for details.
Type requirements
- `ForwardIt` must meet the requirements of LegacyForwardIterator.
- No increment, assignment, comparison, or indirection through valid instances of `ForwardIt` may throw exceptions.

### Return value

(none)

### Complexity

Linear in the distance between `first` and `last`

### Exceptions

The overload with a template parameter named `ExecutionPolicy` reports errors as follows:

- If execution of a function invoked as part of the algorithm throws an exception and `ExecutionPolicy` is one of the standard policies, std::terminate is called. For any other `ExecutionPolicy`, the behavior is implementation-defined.
- If the algorithm fails to allocate memory, std::bad_alloc is thrown.

### Possible implementation

    template<class ForwardIt>
    void uninitialized_default_construct(ForwardIt first, ForwardIt last)
    {
        using Value = typename std::iterator_traits<ForwardIt>::value_type;
        ForwardIt current = first;
        try {
            for (; current != last; ++current) {
                ::new (static_cast<void*>(std::addressof(*current))) Value;
            }
        }  catch (...) {
            std::destroy(first, current);
            throw;
        }
    }

### Example

| This section is incomplete Reason: no example

### See also

uninitialized_default_construct_n (C++17) | constructs objects by default-initialization in an uninitialized area of memory, defined by a start and a count (function template)
uninitialized_value_construct (C++17) | constructs objects by value-initialization in an uninitialized area of memory, defined by a range (function template)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/memory/uninitialized_default_construct&oldid=107310"